/*
To do:

T = needs testing
X = done
- = cancelled

[T] register Ham_Killed instead of using zpnm killed native
[T] CZ bots support
v1.1.2
[ ] 
*/

// Modules
#include <amxmodx>
#include <hamsandwich>

// Plug-in APIs
#include <cs_ham_bots_api>
#include <zombieplaguenightmare>

// Stocks
#include <zp50_colorchat>

new cvar_first, cvar_zombies

public plugin_init()
{
	register_plugin("[ZPNM] Team Balancer", "1.1.2", "D i 5 7 i n c T")
	
	register_dictionary("zpnm_team_balancer.txt")
	
	RegisterHam(Ham_Killed, "player", "fwHamKilledPlayer", 1)
	RegisterHamBots(Ham_Killed, "fwHamKilledPlayer", 1)
	
	cvar_first = register_cvar("zpnm_bonus_hp_first", "5.7")
	cvar_zombies = register_cvar("zpnm_bonus_hp_zombies", "7.5")
}

public client_disconnect(iID)
	remove_task(iID)

public zp_user_infected_post(iID, inf, nem, ass, bomb)
{
	if (nem || ass)
		return;
	
	if (!bomb && zp_has_round_started() == 1 || zp_get_user_first_zombie(iID))
		zpnm_balance(iID)
	else
		set_task(0.1, "zpnm_balance", iID)
}

public zp_user_humanized_post(iID)
	remove_task(iID)

public fwHamKilledPlayer(const iID)
	remove_task(iID)

public zpnm_balance(iID)
{
/*	if (zp_has_round_started() != 1)
	{
		set_task(0.01, "zpnm_balance", iID)
		
		return;
	}
	*/
	static Float:percent
	
	if (!zp_get_user_first_zombie(iID))
		percent = get_pcvar_float(cvar_zombies)
	else
		percent = get_pcvar_float(cvar_first)
	
	if (percent <= 0.0)
		return;
	
	static humans
	humans = zp_get_human_count()
	
	if (!humans)
		return;
	
	static health, maxhealth, Float:bonus
	health = get_user_health(iID)
	maxhealth = zp_get_zombie_maxhealth(iID)
	
	if (health < maxhealth)
		health = maxhealth
	
	bonus = (humans * health * percent) / 100
	
	static iBonus
	iBonus = floatround(bonus)
	
	zpnm_set_user_health(iID, health + iBonus)
	zp_colored_print(iID, "^3%L", iID, "ZPNM_BONUS_HEALTH", iBonus, percent, health, floatround(bonus / humans), humans)
}
