/*
To do:

T = needs testing
X = done
- = cancelled

[T] register Ham_Killed instead of using zpnm killed native
[T] CZ bots support
v1.2.2
[ ] 
*/

// Modules
#include <amxmodx>
#include <hamsandwich>

// Plug-in APIs
#include <cs_ham_bots_api>
#include <zombieplague>

new g_skull

public plugin_init()
{
	register_plugin("[ZPNM] Death Effect", "1.2.2", "defa, D i 5 7 i n c T")
	
	RegisterHam(Ham_Killed, "player", "fwHamKilledPlayer", 1)
	RegisterHamBots(Ham_Killed, "fwHamKilledPlayer", 1)
}

public plugin_precache()
	g_skull = precache_model("sprites/93skull1.spr")

public fwHamKilledPlayer(const iID)
{
	if (!zp_get_user_zombie(iID))
		return;
	
	static origin[3]
	get_user_origin(iID, origin)
	
	set_task(1.757, "ShowDeathSprite", iID, origin, 3)
}

public ShowDeathSprite(origin[3], iID)
{
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
	write_byte(TE_SPRITE)
	write_coord(origin[0])
	write_coord(origin[1])
	write_coord(origin[2] += 30)
	write_short(g_skull)
	write_byte(8)
	write_byte(255)
	message_end()
}
