#include <amxmodx>
#include <zombieplaguenightmare>

new g_anti[33], g_madness[33]

public plugin_init()
	register_plugin("[ZPNM] Limit Base Items", "0.0.1", "D i 5 7 i n c T")

public client_putinserver(id)
{
	g_anti[id] = 0
	g_madness[id] = 0
}

public zp_round_started()
{
	static maxplayers
	if (!maxplayers) maxplayers = get_maxplayers()
	
	for (new i = 1; i <= maxplayers; i++)
	{
		g_anti[i] = 0
		g_madness[i] = 0
	}
}

public zpnm_extra_item_buy_attempt(id, item)
{
	if (item == EXTRA_ANTIDOTE && g_anti[id])
	{
		client_print(id, print_center, "Antidote limit is 1 per round for each player")
		
		return ZP_PLUGIN_HANDLED;
	}
	else if (item == EXTRA_MADNESS && g_madness[id])
	{
		client_print(id, print_center, "Madness limit is 1 per round for each player")
		
		return ZP_PLUGIN_HANDLED;
	}
	
	return PLUGIN_CONTINUE;
}

public zp_extra_item_selected(id, item)
{
	if (item == EXTRA_ANTIDOTE)
		g_anti[id]++
	else if (item == EXTRA_MADNESS)
		g_madness[id]++
}
