#include <amxmodx>
#include <amxmisc>
#include <zombieplaguenightmare>

new g_pCvar_show_activity

new const g_szGiveLANG[7][20] =
{
	"ZPNM_GIVE_PLAYERS",
	"ZPNM_GIVE_HUMANS",
	"ZPNM_GIVE_ZOMBIES",
	"ZPNM_GIVE_SURVIVORS",
	"ZPNM_GIVE_NEMESIS",
	"ZPNM_GIVE_SNIPERS",
	"ZPNM_GIVE_ASSASSINS"
}

new const g_szTakeLANG[7][20] =
{
	"ZPNM_TAKE_PLAYERS",
	"ZPNM_TAKE_HUMANS",
	"ZPNM_TAKE_ZOMBIES",
	"ZPNM_TAKE_SURVIVORS",
	"ZPNM_TAKE_NEMESIS",
	"ZPNM_TAKE_SNIPERS",
	"ZPNM_TAKE_ASSASSINS"
}

new const g_szSetLANG[7][19] =
{
	"ZPNM_SET_PLAYERS",
	"ZPNM_SET_HUMANS",
	"ZPNM_SET_ZOMBIES",
	"ZPNM_SET_SURVIVORS",
	"ZPNM_SET_NEMESIS",
	"ZPNM_SET_SNIPERS",
	"ZPNM_SET_ASSASSINS"
}

public plugin_init()
{
	register_plugin("[ZPNM] Manage Ammo Packs", "2.1.0", "D i 5 7 i n c T")
	register_dictionary("common.txt")
	register_dictionary("zpnm_manage_ampks.txt")
	register_concmd("zpnm_set_ampks", "CmdSetAmpks", ADMIN_RCON, "<name/#all/#hm/#zm/#sv/#nm/#sp/#as> <(+/-)amount>")
	
	g_pCvar_show_activity = register_cvar("zpnm_set_ammo_packs_announce", "1")
}

public CmdSetAmpks(iAdminID, iAccessLevel, iCommandID)
{
	if (!cmd_access(iAdminID, iAccessLevel, iCommandID, 3))
		return PLUGIN_HANDLED;
	
	static szArg1[31], szArg2[11];
	
	read_argv(1, szArg1, 30)
	read_argv(2, szArg2, 10)
	
	if (!isdigit(szArg2[0]))
		szArg2[1] = str_to_num(szArg2[1]);
	else
		szArg2[1] = str_to_num(szArg2);
	
	new iPlayer, iShow = get_pcvar_num(g_pCvar_show_activity);
	
	static szAdminName[36];
	
	if (iShow > 1)
		get_user_name(iAdminID, szAdminName, 30)
	else
		szAdminName = ""
	
	static iMaxPlayers
	if (!iMaxPlayers)
		iMaxPlayers = get_maxplayers()
	
	if (szArg1[0] == '#' && !isdigit(szArg1[1]))
	{
		if (iShow > 1)
			format(szAdminName, 35, " ^3%s^1", szAdminName)
		
		new iFor;
		
//		if (equali(szArg1, "#all"))
//			iFor = 0
		if (equali(szArg1, "#hm"))
			iFor = 1
		else if (equali(szArg1, "#zm"))
			iFor = 2
		else if (equali(szArg1, "#sv"))
			iFor = 3
		else if (equali(szArg1, "#nm"))
			iFor = 4
		else if (equali(szArg1, "#sp"))
			iFor = 5
		else if (equali(szArg1, "#as"))
			iFor = 6
		
		for (iPlayer = 1; iPlayer <= iMaxPlayers; iPlayer++)
		{
			if (!is_user_connected(iPlayer))
				continue;
			
			if (iShow)
			{
				if (szArg2[0] == '+')
					colored_chat(iPlayer, iAdminID, "^1%L%s: ^4%L", iPlayer, "ADMIN", szAdminName, iPlayer, g_szGiveLANG[iFor], szArg2[1])
				else if (szArg2[0] == '-')
					colored_chat(iPlayer, iAdminID, "^1%L%s: ^4%L", iPlayer, "ADMIN", szAdminName, iPlayer, g_szTakeLANG[iFor], szArg2[1])
				else
					colored_chat(iPlayer, iAdminID, "^1%L%s: ^4%L", iPlayer, "ADMIN", szAdminName, iPlayer, g_szSetLANG[iFor], szArg2[1])
			}
			
			if (iFor == 1 && (zp_get_user_zombie(iPlayer) || zp_get_user_survivor(iPlayer) || zpnm_get_user_sniper(iPlayer))
			|| iFor == 2 && (!zp_get_user_zombie(iPlayer) || zp_get_user_nemesis(iPlayer) || zpnm_get_user_assassin(iPlayer))
			|| iFor == 3 && !zp_get_user_survivor(iPlayer) || iFor == 4 && !zp_get_user_nemesis(iPlayer)
			|| iFor == 5 && !zpnm_get_user_sniper(iPlayer) || iFor == 6 && !zpnm_get_user_assassin(iPlayer))
				continue;
			
			if (szArg2[0] == '+')
				zp_set_user_ammo_packs(iPlayer, zp_get_user_ammo_packs(iPlayer) + szArg2[1])
			else if (szArg2[0] == '-')
				zp_set_user_ammo_packs(iPlayer, zp_get_user_ammo_packs(iPlayer) - szArg2[1])
			else
				zp_set_user_ammo_packs(iPlayer, szArg2[1])
		}
	}
	else if ((iPlayer = cmd_target(iAdminID, szArg1, CMDTARGET_ALLOW_SELF)))
	{
		if (szArg2[0] == '+')
			zp_set_user_ammo_packs(iPlayer, zp_get_user_ammo_packs(iPlayer) + szArg2[1])
		else if (szArg2[0] == '-')
			zp_set_user_ammo_packs(iPlayer, zp_get_user_ammo_packs(iPlayer) - szArg2[1])
		else
			zp_set_user_ammo_packs(iPlayer, szArg2[1])
		
		if (!iShow)
			return PLUGIN_HANDLED;
		else if (iShow > 1)
			format(szAdminName, 35, " ^4%s^1", szAdminName)
		
		static szPlayerName[35]
		get_user_name(iPlayer, szPlayerName, 30)
		format(szPlayerName, 34, "^3%s%s", szPlayerName, (szArg2[0] == '+' || szArg2[0] == '-') ? "" : "^4")
		
		new iTarget = iPlayer;
		
		for (iPlayer = 1; iPlayer <= iMaxPlayers; iPlayer++)
		{
			if (!is_user_connected(iPlayer))
				continue;
			
			if (szArg2[0] == '+')
				colored_chat(iPlayer, iTarget, "^1%L%s: ^4%L", iPlayer, "ADMIN", szAdminName, iPlayer, "ZPNM_GIVE_PLAYER", szArg2[1], szPlayerName)
			else if (szArg2[0] == '-')
				colored_chat(iPlayer, iTarget, "^1%L%s: ^4%L", iPlayer, "ADMIN", szAdminName, iPlayer, "ZPNM_TAKE_PLAYER", szArg2[1], szPlayerName)
			else
				colored_chat(iPlayer, iTarget, "^1%L%s: ^4%L", iPlayer, "ADMIN", szAdminName, iPlayer, "ZPNM_SET_PLAYER", szPlayerName, szArg2[1])
		}
	}
	
	return PLUGIN_HANDLED;
}

stock colored_chat(iTarget, iSender, const szMessage[], any:...)
{
	static szBuffer[192]
	
	// Format message for player
	vformat(szBuffer, 191, szMessage, 4)
	
	static msgSayText
	if (!msgSayText)
		msgSayText = get_user_msgid("SayText")
	
	message_begin(MSG_ONE_UNRELIABLE, msgSayText, _, iTarget)
	write_byte(iSender)
	write_string(szBuffer)
	message_end()
}
