/*
To do:

T = needs testing
X = done
- = cancelled

[T] register Ham_Killed instead of using zpnm killed native
[T] CZ bots support
[T] remove zpnm_get_user_alive and use is_user_alive instead
v1.1.3
[ ] 
*/

// Modules
#include <amxmodx>
#include <hamsandwich>

// Plug-in APIs
#include <cs_ham_bots_api>
#include <zombieplaguenightmare>

new g_missing_survivors, g_missing_nemesis

public plugin_init()
{
	register_plugin("[ZPNM] Plague Mode Fix", "1.1.3", "D i 5 7 i n c T")
	
	RegisterHam(Ham_Killed, "player", "fwHamKilledPlayer", 1)
	RegisterHamBots(Ham_Killed, "fwHamKilledPlayer", 1)
}

public client_disconnect(iID)
{
	if (!zp_is_plague_round() || !is_user_alive(iID))
		return;
	
	if (zp_get_user_survivor(iID))
		g_missing_survivors++
	else if (zp_get_user_nemesis(iID))
		g_missing_nemesis++
}

public zp_round_started(mode)
{
	if (mode != MODE_PLAGUE)
		return;
	
	g_missing_survivors = 0
	g_missing_nemesis = 0
}

public zpnm_user_spawn_post(iID)
{
	if (!zp_is_plague_round())
		return;
	
	if (g_missing_survivors)
	{
		zp_make_user_survivor(iID)
		
		g_missing_survivors--
	}
	else if (g_missing_nemesis)
	{
		zp_make_user_nemesis(iID)
		
		g_missing_nemesis--
	}
}

public fwHamKilledPlayer(const iID)
{
	if (!zp_is_plague_round())
		return;
	
	if (zp_get_user_survivor(iID))
		g_missing_survivors++
	else if (zp_get_user_nemesis(iID))
		g_missing_nemesis++
}
